use std::rc::Rc;
use futures::executor::block_on;
use gtk4::prelude::*;
use gtk4::{
    glib::*,
    ApplicationWindow,
    HeaderBar,
    Button,
    Window
};

#[derive(Debug, Downgrade)]
pub struct CustomTitleBar {
    pub window: Window,
    pub titlebar: HeaderBar,
    pub run_button: Button,
    pub type_button: Button,
}

impl CustomTitleBar {
    pub fn new() -> CustomTitleBar {
        CustomTitleBar {
            window: Window::new(),
            titlebar: HeaderBar::new(),
            run_button: Button::new(),
            type_button: Button::new(),
        }
    }

    pub fn set_buttons(&self) {
        // set labels
        self.run_button.set_label("Apply Patch");
        self.type_button.set_label("Patch Type");

        // set css class; it turns blue!
        self.run_button.set_css_classes(&["run_btn"]);

        // set visibility
        self.run_button.set_visible(true);
        self.type_button.set_visible(true);

        // asdf
        
    }

    pub fn click_run_button(&self) {
        self.run_button.connect_clicked(move |button| {
                button.set_label("Avery is awesome!");
        });
    }

    pub fn set_window(&self, window: &ApplicationWindow) {
        window.set_titlebar(Some(&self.titlebar));
    }

    pub fn set_titlebar(&self) {
        self.titlebar.pack_start(&self.run_button);
        self.titlebar.pack_start(&self.type_button);
        self.titlebar.set_css_classes(&["headerbar"])
    }
}